var thingToShare, sharelastpage, sharelastelement, shareActions = [
	{n: 'email', d: 'E-Mail'},
	{n: 'sms', d: 'SMS'},
	{n:'whatsapp', d: 'Whatsapp'},
	{n:'twitter', d: 'Twitter'}
],
shareMenu = new OptionsMenu(i18n('share-via'));

function shareotInit() {
	shareActions.forEach((e) => {
		shareMenu.addOption(e.d);
	})
}

window.addEventListener('DOMContentLoaded',shareotInit);

function shareot(input,returnpage,returnel) {
	thingToShare = input;

	if(returnpage === null || returnpage === undefined) {returnpage = curpage}
	if(returnel === null || returnel === undefined) {returnel = actEl()}
	//doing the above instead of
	//	sharelastpage = curpage || returnpage
	//because 0 is false in javascript's logic
	sharelastpage = returnpage;
	sharelastelement = returnel;

	curpage = 100;
	shareMenu.menuViewToggle(true);
	shareMenu.menu.children[0].focus();

}

function shareCMA(method) { //share Call MozActivity
	method = shareActions[method].n;
	var mza;
	switch(method) {
		case 'email':
			mza = new MozActivity({
				name: 'new',
				data: {
					type: 'mail',
					URI: 'mailto:?body=' + encodeURIComponent(thingToShare), //for email
					//body: input //for text messaging
			}});
			break;
		case 'sms':
			mza = new MozActivity({
				name: 'new',
				data: {
					type: 'websms/sms',
					body: thingToShare //for text messaging
			}});
			break;
		case 'whatsapp':
			mza = new MozActivity({
				name: 'view',
				data: {
					type: 'url',
					url: 'https://wa.me/?text=' + encodeURIComponent(thingToShare)
			}});
			break;
		case 'twitter':
			mza = new MozActivity({
				name: 'view',
				data: {
					type: 'url',
					url: 'http://twitter.com/share?text=' + encodeURIComponent(thingToShare)
			}});
			break;
	}

	mza.onerror = function(e){
		console.log(e);
		switch(e.target.error.name) {
			case 'NO_PROVIDER': alertMessage('App not found.',5000,0); break;
			case 'ActivityCanceled': alertMessage('Share canceled.',5000,0); shareotReturn(); break;
			default: alertMessage('Share failed.'); break;
		}
	}
	mza.onsuccess = shareotReturn;
}


function shareotK(k) {
	switch(k.key) {
		case 'Backspace':
		case 'SoftLeft':
			shareotReturn();
			k.preventDefault();
			break;
		case 'ArrowUp':   navigatelist(Number(actEl().tabIndex), shareMenu.menu.children, -1); break;
		case 'ArrowDown': navigatelist(Number(actEl().tabIndex), shareMenu.menu.children, 1); break;
		case 'Enter': shareCMA(Number(actEl().tabIndex));
	}
}
function shareotReturn() {
	shareMenu.menuViewToggle(false);
	curpage = sharelastpage;
	sharelastelement.focus();
}