var scrollNameState = 0, 
scrollNameTO = 0, 
scrollNameAnimFrame = 0, 
scrollElement = [], 
scrollSpeed = 1 + getSettingValue('text-scroll-speed'),
scrollResetDelay = 500 * (4 - getSettingValue('text-scroll-speed')); //text-scroll-speed is 3 maximum. 
function scrollName() {
    switch(scrollNameState) {
        case 0: //before scroll start
            scrollNameTO = setTimeout(scrollName, scrollResetDelay);
            scrollNameState = 1;
            break;
        case 1: //scrolling

            scrollElement.forEach((e)=>{
                if(
                    (e.e.offsetLeft - e.p) * -1 > 
                    e.e.offsetWidth - e.e.parentElement.offsetWidth + (e.p * 2)
                ) {
                    scrollNameTO = setTimeout(() => {
                        resetScrollName();
                    }, scrollResetDelay);
                    return;
                }
                scrollNameAnimFrame = requestAnimationFrame(scrollName);
                e.e.style.left = (e.e.offsetLeft - e.p - scrollSpeed) + 'px';
            })
        break;
    }
}

function resetScrollName(noProceed) {
    scrollNameState = 0;
    clearTimeout(scrollNameTO);
    scrollElement.forEach((e) => {
        e.e.style.left = null;
    });
    cancelAnimationFrame(scrollNameAnimFrame);
    if(noProceed !== true) {
        scrollName();
    }
}
