var videoActionOverflowMenu = new OptionsMenu(i18n('video-actions'));

[
    ['seek-to', 'video-action-seek-to'],
    /* ['add-to-playlist', 'add-to-playlist'], */
    ['loop-toggle', 'video-action-loop-toggle'],
    ['change-video-fit', 'video-action-change-video-fit'],
].forEach((e)=>{
    var ss = videoActionOverflowMenu.addOption(i18n(e[1]));
    ss.dataset.action = e[0];
});

function showVideoActionOverflowMenu() {
    videoActionOverflowMenu.menuViewToggle(true);
    videoActionOverflowMenu.menu.children[0].focus();
    curpage = 6;
}

function overflowVideoActionsK(k) {
    switch(k.key) {
        case 'ArrowDown':
            navigatelist(actEl().tabIndex, videoActionOverflowMenu.menu.children, 1);
            break;
        case 'ArrowUp':
            navigatelist(actEl().tabIndex, videoActionOverflowMenu.menu.children, -1);
            break;
        case 'Enter':
            actionsSelect(actEl().dataset.action);
        case 'SoftLeft':
        case 'Backspace':
            videoActionOverflowMenu.menuViewToggle(false);
            navFocus(5);
            break;
    }
}