var curpage = 0,
/* 
0 - main screen
1 - description
2 - video actions
3 - related videos
4 - captions menu
*/
videoSeekAmount = [5,10,15,30][getSettingValue('video-seek-time')];

function keyHandler(k) {
    switch(curpage) {
        case 0: mainScreenK(k); break;
        case 1: descriptionK(k); break;
        case 2: actionK(k); break;
        case 3: relatedK(k); break;
        case 4: captionK(k); break;
        case 5: break; //commentsK(); break;
        case 6: overflowVideoActionsK(k); break;
    }
    //global, runs no matter what
    switch(k.key) {
        case 'ArrowUp':
        case 'ArrowDown':
        case 'ArrowLeft':
        case 'ArrowRight':
            if([1,5].indexOf(curpage) === -1) {
                k.preventDefault();
            }
        
    }
}

function mainScreenK(k) {
    switch(k.key) {
        case 'Enter':
            if(videoAbleToPlay) {
                clearTimeout(audioResyncTimeout);
                var v = output.video;
                if(v.paused){
                    v.play();
                }else{
                    v.pause();
                }
            }
            break;
        case '2': fsToggle(); break;
        case '1': playlistNextVideo(false); break;
        case '3': playlistNextVideo(true);  break;
        case '4': toggleVideoLoop(); break;
        case '5': toggleVideoFit(); break;
        case '6': skipSegmentManual(); break;
        case '9': toggleSegmentSkipping(); break;
        case 'ArrowLeft':  videoSeek(false); break;
        case 'ArrowRight': videoSeek(true); break;
        case 'ArrowUp': navigator.volumeManager.requestUp(); break;
        case 'ArrowDown': navigator.volumeManager.requestDown(); break;
        case 'SoftLeft': toggleVideoInfo();break;
        case 'SoftRight':actionsShow(true);break;
        case 'Backspace':
            if(getFullScreenElement()) {
                fsToggle(false);
            } else {
                backHistory();
            }
            break;
    }
  
}
